require'stringutil'

conn = db.connect{
   api=db.SQL_SERVER,
   name='test', 
   user='',
   password='',
   live=true}

local function trace(a,b,c,d) return end

function main(Data)
   -- convert non-conformant terminators to "\r"
   Data = convertTerminators(Data)
   
   -- split batch into array of messages
   local Msgs=splitBatch(Data)
   
   -- process messages
   for i=1,#Msgs do
      processMsg(Msgs[i])
   end
end

function splitBatch(Data)
   
   -- strip batch info off Data
   local a = Data:split('\r')    
   Data=a[3]
   trace(Data)
   for i=4,#a-2 do
      Data=Data..'\r'..a[i]
   end
   trace(Data)
   
   -- split Data into messages
   local delimiter='MSH|^~\\&|'
   local b=Data:split(delimiter)

   -- add MSH segment info
   trace(b)
   for i=2,#b do 
      b[i-1]=delimiter..b[i]
   end
   b[#b]=nil -- delete dup msg
   trace(b)
   
   -- SOME IDEAS THAT COULD BE USEFUL

   -- global variable to count messages
   MsgCnt = #b
   trace('Messages Count '..MsgCnt)
   
   -- globals for batch segment info
   FHS=a[1]:split('|')
   BHS=a[2]:split('|')
   FTS=a[#a]:split('|') 
   BTS=a[#a-1]:split('|') 
   
   return b
end


function processMsg(Msg)
   local Tables = MapData(Msg) 
   --[[  Some data can be written to database
   conn.merge{data=Tables,live=true}]]   
   return 
end


function MapData(Msg)
   local msg, name = hl7.parse{vmd='demo.vmd', data= Msg}
   local out = db.tables{vmd='demo.vmd', name=name}
   --[[ Do some mapping and 'return' 
   result to calling function]]   
   return out
end

function convertTerminators(Data)
   Data = Data:gsub('\r\n','\r')
   return Data:gsub('\n','\r')
end